$Popcorn::EatTimeout = 3.0; //seconds between eating time, stops spam
$Popcorn::PlaySound = 1; //0: no sounds
$Popcorn::PlayAnimation = 1; //0: no animation on eat
$Popcorn::Consume = 0; //if 1 it will delete the item on eat

datablock AudioProfile(crunch1Sound)
{
	filename = "./crunch1.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(crunch2Sound)
{
	filename = "./crunch2.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(crunch3Sound)
{
	filename = "./crunch3.wav";
	description = AudioClose3d;
	preload = true;
};

datablock ItemData(PopcornItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./popcorn.dts";
	rotate = false;
	mass = 1;
	density = 0.3;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Popcorn Small";
	iconName = "./icon_popcorn";
	doColorShift = false;

	image = PopcornImage;
	canDrop = true;
};

datablock ShapeBaseImageData(PopcornImage)
{
	shapeFile = "./popcorn.dts";
	emap = true;
	
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = eulerToMatrix( "0 0 0" );
	
	className = "WeaponImage";
	
	item = PopcornItem;
	ammo = " ";
	projectile = "";
	projectileType = "";
	
	melee = false;
	armReady = true;
	
	doColorShift = false;
	
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.0;
	stateTransitionOnTimeout[0]     = "EatTimeout";
	
	stateName[1]					= "EatTimeout";
	stateTimeoutValue[1]			= $Popcorn::EatTimeout;
	stateTransitionOnTimeout[1]		= "Ready";
	
	stateName[2]                    = "Ready";
	stateTransitionOnTriggerDown[2] = "Fire";
	stateAllowImageChange[2]        = true;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.10;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = true;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		     = true;
	stateSequence[3]                = "Fire";

	stateName[4]                    = "CheckFire";
	stateTransitionOnTriggerUp[4]   = "StopFire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "EatTimeout";
	stateTimeoutValue[5]            = 0.01;
	stateAllowImageChange[5]        = true;
	stateWaitForTimeout[5]          = true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
};

datablock ItemData(PopcornLargeItem : PopcornItem)
{
	shapeFile = "./popcornLarge.dts";
	mass = 1.1;
	uiName = "Popcorn Large";
	iconName = "./icon_popcornLarge";
	image = PopcornLargeImage;
};

datablock ShapeBaseImageData(PopcornLargeImage : PopcornImage)
{
	shapeFile = "./popcornLarge.dts";
	offset = "-0.53 0.3 -0.1"; //important
	item = PopcornLargeItem;
};

function EatPopcorn(%this, %obj)
{
	if($Popcorn::PlaySound)
	{
		%num = getRandom(1,3);
		serverPlay3D(crunch @ %num @ Sound, %obj.getPosition());
	}
	if($Popcorn::PlayAnimation)
		%obj.playThread(3, "plant");
	if($Popcorn::Consume)
	{
		%slot = %obj.currTool;
		%obj.tool[%slot] = 0;
		%obj.weaponcount--;
		%obj.unMountImage(0);
		messageClient(%obj.client, 'MsgItemPickup', '', %slot, 0);
		serverCmdUnUseTool(%obj.client);
	}
}

function PopcornImage::onFire(%this, %obj, %slot)
{
	EatPopcorn(%this, %obj);
}

function PopcornLargeImage::onFire(%this, %obj, %slot)
{
	EatPopcorn(%this, %obj);
}

function PopcornLargeImage::onMount(%this, %obj, %slot)
{
	%obj.playThread(0, "armReadyBoth");
	parent::onMount(%this, %obj, %slot);
}

function PopcornLargeImage::onUnMount(%this, %obj, %slot)
{
	%obj.playThread(0, "root");
	parent::onUnMount(%this, %obj, %slot);
}